package com.huimv.eartag2.server;

import com.alibaba.fastjson.JSONArray;
import com.huimv.eartag2.service.IDataService;
import com.huimv.eartag2.service.IDeviceService;
import com.huimv.eartag2.utils.DateUtil2;
import com.huimv.eartag2.utils.RegexUtil;
import io.netty.buffer.ByteBuf;
import io.netty.buffer.Unpooled;
import io.netty.channel.ChannelHandler;
import io.netty.channel.ChannelHandlerContext;
import io.netty.channel.ChannelInboundHandlerAdapter;
import io.netty.util.CharsetUtil;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.util.regex.Matcher;
import java.util.regex.Pattern;

/**
 * @Project : huimv.shiwan
 * @Package : com.huimv.biosafety.uface.controller
 * @Description : TODO
 * @Version : 1.0
 * @Author : ZhuoNing
 * @Create : 2020-12-25
 **/
@ChannelHandler.Sharable
@Component
@Slf4j
public class EartagServerHandler2 extends ChannelInboundHandlerAdapter {
    @Autowired
    private IDataService eartagDataService;
    @Autowired
    private DateUtil2 dateUtil;
    @Autowired
    private RegexUtil regexUtil;
    @Autowired
    private IDeviceService deviceService;

    @Override
    public void channelRead(ChannelHandlerContext ctx, Object msg) throws Exception {
        ByteBuf data = (ByteBuf) msg;
        String clientAskText = data.toString(CharsetUtil.UTF_8);
//        clientAskText = clientAskText.replaceAll("\r","").replaceAll("\n","");
        System.out.println("### 服务端接收数据 >>"+clientAskText);

        //test-saveRawData()
        deviceService.saveRawData(clientAskText);

        //{}
        int countPlus = regexUtil.countPlus(clientAskText);
        if(countPlus < 4){
            System.out.println("当前数据为不完整数据，故丢弃.>>"+clientAskText);
        }else{
            //--处理客户端请求数据
//            System.out.println("000拆分粘包之前数据 clientAskText>>"+clientAskText);
            //{拆分粘包数据}
            JSONArray askJa = getPerData(clientAskText);
            for (int a = 0; a < askJa.size(); a++) {
                //先判断是否再所有牧场的集合当中，未登记都过滤掉；
//                cacheService.isValidDevice(deviceCode);
                //{处理客户端请求数据}
                String answer = eartagDataService.handleClientAsk(askJa.getString(a), ctx);
                System.out.println("## 返回应答>>"+answer);
                if (answer != null) {
                    log.info("###应答响应>>" + answer + "\n");
                    ctx.writeAndFlush(Unpooled.copiedBuffer(answer.getBytes()));
                } else {
                    log.info("###应答数据>>" + answer + "，不需要应答。\n");
                }
            }
        }
    }

//    @Override
    public void channelRead_old1(ChannelHandlerContext ctx, Object msg) throws Exception {
        ByteBuf data = (ByteBuf) msg;
        String clientAskText = data.toString(CharsetUtil.UTF_8);
        System.out.println("### 服务端接收数据 >>"+clientAskText);
        if(clientAskText.length() <=18){
            System.out.println("当前数据为不完整数据，故丢弃.>>"+clientAskText);
        }else{
            //--处理客户端请求数据
//            String answer = eartagDataService.handleClientAsk(clientAskText, ctx);
////            String answer = eartagDataService.handleClientAsk(clientAsk, ctx);
//            if (answer != null) {
//                log.info("###应答响应>>" + answer + "\n");
//                ctx.writeAndFlush(Unpooled.copiedBuffer(answer.getBytes()));
//            } else {
//                log.info("###应答数据>>" + answer + "，不需要应答。\n");
//            }
//            System.out.println("000拆分粘包之前数据 clientAskText>>"+clientAskText);
//            --拆分粘包数据
            JSONArray askJa = getPerData(clientAskText);
            for (int a = 0; a < askJa.size(); a++) {
                //--处理客户端请求数据
                String answer = eartagDataService.handleClientAsk(askJa.getString(a), ctx);
//            String answer = eartagDataService.handleClientAsk(clientAsk, ctx);
                if (answer != null) {
                    log.info("###应答响应>>" + answer + "\n");
                    ctx.writeAndFlush(Unpooled.copiedBuffer(answer.getBytes()));
                } else {
                    log.info("###应答数据>>" + answer + "，不需要应答。\n");
                }
            }
        }
    }

    //拆分粘包数据
    public JSONArray getPerData(String text) {
        String key = "end";
        Pattern pattern = Pattern.compile(key);
        Matcher matcher = pattern.matcher(text);
        int count = 0;
        while (matcher.find()) {
            count++;
        }
        JSONArray dataJa = new JSONArray();
        if (count == 1) {
            dataJa.add(text);
        } else {
            for (int a = 0; a < count; a++) {
                int p1 = text.indexOf("end");
                dataJa.add(text.substring(0, p1 + 3));
                text = text.substring(p1 + 3, text.length());
            }
        }
        return dataJa;
    }

    @Override
    public void channelReadComplete(ChannelHandlerContext ctx) throws Exception {
//        ctx.writeAndFlush("111");
//        System.out.println("EchoServerHandle channelReadComplete");
    }

    @Override
    public void exceptionCaught(ChannelHandlerContext ctx, Throwable cause) throws Exception {
        cause.printStackTrace();
        ctx.close();

    }
}
